]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
sshfs: Add $(MAKETUNING) variable to ninja build
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06fc566a 20# Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
255273a3 28VERSION="2.27" # Version number
4bf13a6a 29CORE="160" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 32MAX_RETRIES=1 # prefetch/check loop
305a7b38 33BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 34KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
35
36# Information from Git
37GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38GIT_TAG="$(git tag | tail -1)" # Git Tag
39GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 40
5e7ba4f4 41TOOLCHAINVER=20210701
03ad5f93 42
178eaf31
AF
43# use multicore and max compression
44ZSTD_OPT="-T0 --ultra -22"
d66e6fa8 45
69a6ec55
MT
46###############################################################################
47#
48# Beautifying variables & presentation & input output interface
49#
50###############################################################################
51
f9783277
MT
52# Remember if the shell is interactive or not
53if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55else
56 INTERACTIVE=false
57fi
58
401a1edc
MT
59# Sets or adjusts pretty formatting variables
60resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69a6ec55 69
401a1edc
MT
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
e9a57acd
MT
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 79}
69a6ec55 80
401a1edc
MT
81# Initially setup terminal
82resize_terminal
f9783277 83
401a1edc
MT
84# Call resize_terminal when terminal is being resized
85trap "resize_terminal" WINCH
69a6ec55
MT
86
87# Define color for messages
88BOLD="\\033[1;39m"
89DONE="\\033[1;32m"
90SKIP="\\033[1;34m"
91WARN="\\033[1;35m"
92FAIL="\\033[1;31m"
93NORMAL="\\033[0;39m"
94
bcb9dc13 95# New architecture variables
dc7d6b20 96HOST_ARCH="$(uname -m)"
94571564 97
69a6ec55
MT
98PWD=$(pwd)
99BASENAME=$(basename $0)
100
15679d9f
MT
101# Debian specific settings
102if [ ! -e /etc/debian_version ]; then
df5e82b3 103 FULLPATH=`which $0`
15679d9f 104else
df5e82b3
MT
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
15679d9f 111fi
df5e82b3 112
69a6ec55 113# This is the directory where make.sh is in
aecbe123 114export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 115
ebaecf2c
AF
116LOGFILE=$BASEDIR/log/_build.preparation.log
117export LOGFILE
15679d9f 118DIR_CHK=$BASEDIR/cache/check
ebaecf2c 119mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 120
69a6ec55
MT
121system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123}
124
125system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137}
138
139configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
148 BUILDTARGET="${build_arch}-unknown-linux-gnu"
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
5eec0f21 151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
69a6ec55
MT
152 ;;
153
154 i586)
155 BUILDTARGET="${build_arch}-pc-linux-gnu"
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="x86"
cf58f659 158 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
159 ;;
160
161 aarch64)
162 BUILDTARGET="${build_arch}-unknown-linux-gnu"
163 CROSSTARGET="${build_arch}-cross-linux-gnu"
164 BUILD_PLATFORM="arm"
87f3b1e5 165 CFLAGS_ARCH="-fstack-clash-protection"
69a6ec55
MT
166 ;;
167
168 armv7hl)
169 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
172 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
173 ;;
174
aafdd71b 175 armv6l)
69a6ec55
MT
176 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
177 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
178 BUILD_PLATFORM="arm"
f3fda4d3 179 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
aafdd71b 180 #RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
181 ;;
182
161eb15d
MT
183 riscv64)
184 BUILDTARGET="${build_arch}-unknown-linux-gnu"
185 CROSSTARGET="${build_arch}-cross-linux-gnu"
186 BUILD_PLATFORM="riscv"
0c304b7b 187 CFLAGS_ARCH="-fstack-clash-protection"
161eb15d
MT
188 ;;
189
69a6ec55
MT
190 *)
191 exiterror "Cannot build for architure ${build_arch}"
192 ;;
193 esac
194
195 # Check if the QEMU helper is available if needed.
196 if qemu_is_required "${build_arch}"; then
197 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
198
199 if [ -n "${qemu_build_helper}" ]; then
200 QEMU_TARGET_HELPER="${qemu_build_helper}"
201 else
202 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
203 fi
204 fi
205
206 BUILD_ARCH="${build_arch}"
207 TOOLS_DIR="/tools_${BUILD_ARCH}"
208
209 # Enables hardening
54114eb0 210 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
211
212 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
213 CXXFLAGS="${CFLAGS}"
214
215 # Determine parallelism
eeee108f 216 # We assume that each process consumes about
297473d5 217 # 128MB of memory. Therefore we find out how
eeee108f 218 # many processes fit into memory.
297473d5 219 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
72c39057 220 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
eeee108f
MT
221
222 local parallelism
223 if [ ${mem_max} -lt ${cpu_max} ]; then
224 parallelism=${mem_max}
225 else
226 parallelism=${cpu_max}
69a6ec55 227 fi
212f17c1 228
eeee108f
MT
229 # Use this as default PARALLELISM
230 DEFAULT_PARALLELISM="${parallelism}"
231
e1616eb4
SS
232 # Limit lauched ninja build jobs to computed parallel value.
233 NINJAJOBS="${parallelism}"
234
212f17c1
MT
235 # Compression parameters
236 # We use mode 8 for reasonable memory usage when decompressing
237 # but with overall good compression
238 XZ_OPT="-8"
239
240 # We try to use as many cores as possible
241 XZ_OPT="${XZ_OPT} -T0"
242
243 # We need to limit memory because XZ uses too much when running
244 # in parallel and it isn't very smart in limiting itself.
245 # We allow XZ to use up to 70% of all system memory.
deffc275 246 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
247
248 # XZ memory cannot be larger than 2GB on 32 bit systems
249 case "${build_arch}" in
250 i*86|armv*)
251 if [ ${xz_memory} -gt 2048 ]; then
252 xz_memory=2048
253 fi
254 ;;
255 esac
256
257 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
258}
259
260configure_build_guess() {
261 case "${HOST_ARCH}" in
87487585
MT
262 x86_64)
263 echo "x86_64"
264 ;;
265 i?86)
69a6ec55
MT
266 echo "i586"
267 ;;
268
269 aarch64)
270 echo "aarch64"
271 ;;
272
aafdd71b
AF
273 armv7*|armv6*)
274 echo "armv6l"
69a6ec55
MT
275 ;;
276
161eb15d
MT
277 riscv64)
278 echo "riscv64"
279 ;;
280
69a6ec55
MT
281 *)
282 exiterror "Cannot guess build architecture"
283 ;;
284 esac
285}
286
f9783277
MT
287stdumount() {
288 umount $BASEDIR/build/sys 2>/dev/null;
289 umount $BASEDIR/build/dev/shm 2>/dev/null;
290 umount $BASEDIR/build/dev/pts 2>/dev/null;
291 umount $BASEDIR/build/dev 2>/dev/null;
292 umount $BASEDIR/build/proc 2>/dev/null;
293 umount $BASEDIR/build/install/mnt 2>/dev/null;
294 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
295 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
296 umount $BASEDIR/build/usr/src/config 2>/dev/null;
297 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
298 umount $BASEDIR/build/usr/src/html 2>/dev/null;
299 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
300 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 301 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 302 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 303 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 304 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
305}
306
307now() {
308 date -u "+%s"
69a6ec55
MT
309}
310
f9783277
MT
311format_runtime() {
312 local seconds=${1}
313
314 if [ ${seconds} -ge 3600 ]; then
315 printf "%d:%02d:%02d\n" \
316 "$(( seconds / 3600 ))" \
317 "$(( seconds % 3600 / 60 ))" \
318 "$(( seconds % 3600 % 60 ))"
319 elif [ ${seconds} -ge 60 ]; then
320 printf "%d:%02d\n" \
321 "$(( seconds / 60 ))" \
322 "$(( seconds % 60 ))"
69a6ec55 323 else
f9783277 324 printf "%d\n" "${seconds}"
69a6ec55 325 fi
f9783277 326}
69a6ec55 327
f9783277
MT
328print_line() {
329 local line="$@"
69a6ec55 330
f9783277 331 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
332}
333
f9783277
MT
334_print_line() {
335 local status="${1}"
336 shift
69a6ec55 337
f9783277
MT
338 if ${INTERACTIVE}; then
339 printf "${!status}"
340 fi
69a6ec55 341
f9783277
MT
342 print_line "$@"
343
344 if ${INTERACTIVE}; then
345 printf "${NORMAL}"
346 fi
347}
348
349print_headline() {
350 _print_line BOLD "$@"
69a6ec55
MT
351}
352
f9783277
MT
353print_error() {
354 _print_line FAIL "$@"
355}
356
357print_package() {
358 local name="${1}"
359 shift
69a6ec55 360
f9783277
MT
361 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
362 local options="$@"
363
364 local string="${name}"
365 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
366 string="${string} (${version})"
367 fi
368
369 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 370 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
371}
372
373print_runtime() {
374 local runtime=$(format_runtime $@)
375
376 if ${INTERACTIVE}; then
377 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
378 else
379 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 380 fi
f9783277
MT
381}
382
383print_status() {
384 local status="${1}"
385
386 local color="${!status}"
387
388 if ${INTERACTIVE}; then
389 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
390 else
391 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 392 fi
f9783277 393}
69a6ec55 394
f9783277
MT
395print_build_stage() {
396 print_headline "$@"
397
398 # end line
399 printf "\n"
69a6ec55
MT
400}
401
f9783277
MT
402print_build_summary() {
403 local runtime=$(format_runtime $@)
404
405 print_line "*** Build finished in ${runtime}"
406 print_status DONE
69a6ec55
MT
407}
408
409exiterror() {
410 stdumount
411 for i in `seq 0 7`; do
412 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
413 losetup -d /dev/loop${i} 2>/dev/null
414 fi;
415 done
416
f9783277 417 # Dump logfile
66028310 418 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
419 echo # empty line
420
421 local line
422 while read -r line; do
423 echo " ${line}"
424 done <<< "$(tail -n30 ${LOGFILE})"
425 fi
426
f9783277
MT
427 echo # empty line
428
429 local line
430 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
431 print_error "${line}"
432 print_status FAIL
433 done
434
69a6ec55
MT
435 exit 1
436}
437
aecbe123
MT
438prepareenv() {
439 # Are we running the right shell?
54328605 440 if [ -z "${BASH}" ]; then
aecbe123
MT
441 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
442 fi
443
444 if [ -z "${BASH_VERSION}" ]; then
445 exiterror "Not running BASH shell."
446 fi
447
448 # Trap on emergency exit
449 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
450
aecbe123 451 # Checking if running as root user
658232a6 452 if [ $(id -u) -ne 0 ]; then
df7f30a1 453 exiterror "root privileges required for building"
aecbe123
MT
454 fi
455
456 # Checking for necessary temporary space
f9783277 457 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
458 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
459 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
460 if (( 2048000 > $BASE_ASPACE )); then
461 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
462 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 463 print_status FAIL
aecbe123
MT
464 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
465 fi
466 else
f9783277 467 print_status DONE
aecbe123
MT
468 fi
469
470 # Set umask
471 umask 022
472
473 # Set LFS Directory
474 LFS=$BASEDIR/build
475
aecbe123
MT
476 # Setup environment
477 set +h
478 LC_ALL=POSIX
e1616eb4 479 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
480 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
481
482 # Make some extra directories
483 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
484 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
485 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
380aa6e5 486 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
7c984de6
MT
487
488 if [ "${ENABLE_RAMDISK}" = "on" ]; then
489 mkdir -p $BASEDIR/build/usr/src
815ca15d 490 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
491
492 mkdir -p ${BASEDIR}/build/tmp
493 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
494 fi
495
ebaecf2c 496 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
497
498 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
499 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
500
501 # Make all sources and proc available under lfs build
502 mount --bind /dev $BASEDIR/build/dev
503 mount --bind /dev/pts $BASEDIR/build/dev/pts
504 mount --bind /dev/shm $BASEDIR/build/dev/shm
505 mount --bind /proc $BASEDIR/build/proc
506 mount --bind /sys $BASEDIR/build/sys
507 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
380aa6e5 508 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
aecbe123
MT
509 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
510 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
511 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
512 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
513 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 514 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
515 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
516
517 # Run LFS static binary creation scripts one by one
518 export CCACHE_DIR=$BASEDIR/ccache
36065e42 519 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
520 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
521
522 # Remove pre-install list of installed files in case user erase some files before rebuild
523 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
524
525 # Prepare string for /etc/system-release.
f48643e5
MT
526 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
527
528 case "${GIT_BRANCH}" in
529 core*|beta?|rc?)
530 system_release="${system_release} - ${GIT_BRANCH}"
531 ;;
532 *)
9ff65bfa 533 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 534 ;;
aecbe123 535 esac
4e54a8e2 536
f48643e5
MT
537 # Append -dirty tag for local changes
538 if [ "$(git status -s | wc -l)" != "0" ]; then
539 system_release="${system_release}-dirty"
540 fi
541
542 # Export variable
543 SYSTEM_RELEASE="${system_release}"
544
040160c7
MT
545 # Decide on PAKFIRE_TREE
546 case "${GIT_BRANCH}" in
547 core*)
548 PAKFIRE_TREE="stable"
549 ;;
550 master)
551 PAKFIRE_TREE="testing"
552 ;;
553 *)
554 PAKFIRE_TREE="unstable"
555 ;;
556 esac
557
4e54a8e2
MT
558 # Setup ccache cache size
559 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
560}
561
69a6ec55
MT
562enterchroot() {
563 # Install QEMU helper, if needed
564 qemu_install_helper
565
566 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
567
568 PATH="${PATH}" chroot ${LFS} env -i \
569 HOME="/root" \
570 TERM="${TERM}" \
571 PS1="${PS1}" \
572 PATH="${PATH}" \
573 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 574 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
575 NAME="${NAME}" \
576 SNAME="${SNAME}" \
577 VERSION="${VERSION}" \
578 CORE="${CORE}" \
579 SLOGAN="${SLOGAN}" \
580 TOOLS_DIR="${TOOLS_DIR}" \
581 CONFIG_ROOT="${CONFIG_ROOT}" \
582 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
583 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 584 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
585 BUILDTARGET="${BUILDTARGET}" \
586 CROSSTARGET="${CROSSTARGET}" \
587 BUILD_ARCH="${BUILD_ARCH}" \
588 BUILD_PLATFORM="${BUILD_PLATFORM}" \
589 CCACHE_DIR=/usr/src/ccache \
36065e42 590 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55 591 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 592 GOCACHE="/usr/src/ccache/go" \
69a6ec55 593 KVER="${KVER}" \
0d7a6f03 594 XZ_OPT="${XZ_OPT}" \
77c863a2 595 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
596 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
597 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
598 $(fake_environ) \
599 $(qemu_environ) \
600 "$@"
601}
602
603entershell() {
604 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
605 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
606 fi
607
608 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 609 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
610
611 if enterchroot bash -i; then
612 stdumount
613 else
f9783277 614 print_status FAIL
69a6ec55
MT
615 exiterror "chroot error"
616 fi
617}
618
619lfsmakecommoncheck() {
620 # Script present?
621 if [ ! -f $BASEDIR/lfs/$1 ]; then
622 exiterror "No such file or directory: $BASEDIR/$1"
623 fi
624
f9783277
MT
625 # Print package name and version
626 print_package $@
69a6ec55
MT
627
628 # Check if this package is supported by our architecture.
629 # If no SUP_ARCH is found, we assume the package can be built for all.
630 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
631 # Check if package supports ${BUILD_ARCH} or all architectures.
632 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 633 print_runtime 0
f9783277 634 print_status SKIP
69a6ec55
MT
635 return 1
636 fi
637 fi
638
639 # Script slipped?
640 local i
641 for i in $SKIP_PACKAGE_LIST
642 do
643 if [ "$i" == "$1" ]; then
f9783277 644 print_status SKIP
69a6ec55
MT
645 return 1;
646 fi
647 done
648
649 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
650
651 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
652 MESSAGE="$1\t " download >> $LOGFILE 2>&1
653 if [ $? -ne 0 ]; then
654 exiterror "Download error in $1"
655 fi
656
657 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
658 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
659 if [ $? -ne 0 ]; then
660 exiterror "md5sum error in $1, check file in cache or signature"
661 fi
662
663 return 0 # pass all!
664}
665
666lfsmake1() {
667 lfsmakecommoncheck $*
668 [ $? == 1 ] && return 0
669
69a6ec55
MT
670 cd $BASEDIR/lfs && env -i \
671 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
4301024b 672 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
36065e42 673 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
674 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
675 CFLAGS="${CFLAGS}" \
676 CXXFLAGS="${CXXFLAGS}" \
77c863a2 677 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
678 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
679 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
680 make -f $* \
681 TOOLCHAIN=1 \
682 TOOLS_DIR="${TOOLS_DIR}" \
683 CROSSTARGET="${CROSSTARGET}" \
684 BUILDTARGET="${BUILDTARGET}" \
685 BUILD_ARCH="${BUILD_ARCH}" \
686 BUILD_PLATFORM="${BUILD_PLATFORM}" \
687 LFS_BASEDIR="${BASEDIR}" \
688 ROOT="${LFS}" \
689 KVER="${KVER}" \
f9783277 690 install >> $LOGFILE 2>&1 &
69a6ec55 691
f9783277
MT
692 if ! wait_until_finished $!; then
693 print_status FAIL
694 exiterror "Building $*"
69a6ec55
MT
695 fi
696
f9783277 697 print_status DONE
69a6ec55
MT
698}
699
700lfsmake2() {
701 lfsmakecommoncheck $*
702 [ $? == 1 ] && return 0
703
69a6ec55
MT
704 local PS1='\u:\w$ '
705
706 enterchroot \
ce9264a1 707 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
708 make -f $* \
709 LFS_BASEDIR=/usr/src install" \
f9783277 710 >> ${LOGFILE} 2>&1 &
69a6ec55 711
f9783277
MT
712 if ! wait_until_finished $!; then
713 print_status FAIL
714 exiterror "Building $*"
69a6ec55
MT
715 fi
716
f9783277 717 print_status DONE
69a6ec55
MT
718}
719
720ipfiredist() {
721 lfsmakecommoncheck $*
722 [ $? == 1 ] && return 0
723
69a6ec55
MT
724 local PS1='\u:\w$ '
725
726 enterchroot \
727 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 728 >> ${LOGFILE} 2>&1 &
69a6ec55 729
f9783277
MT
730 if ! wait_until_finished $!; then
731 print_status FAIL
732 exiterror "Packaging $*"
733 fi
69a6ec55 734
f9783277
MT
735 print_status DONE
736}
737
738wait_until_finished() {
739 local pid=${1}
740
741 local start_time=$(now)
742
743 # Show progress
744 if ${INTERACTIVE}; then
745 # Wait a little just in case the process
746 # has finished very quickly.
747 sleep 0.1
748
749 local runtime
750 while kill -0 ${pid} 2>/dev/null; do
751 print_runtime $(( $(now) - ${start_time} ))
752
753 # Wait a little
754 sleep 1
755 done
69a6ec55 756 fi
f9783277
MT
757
758 # Returns the exit code of the child process
759 wait ${pid}
760 local ret=$?
761
762 if ! ${INTERACTIVE}; then
763 print_runtime $(( $(now) - ${start_time} ))
764 fi
765
766 return ${ret}
69a6ec55
MT
767}
768
769fake_environ() {
770 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
771
772 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
773
774 # Fake kernel version, because some of the packages do not compile
775 # with kernel 3.0 and later.
8634797e 776 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
777
778 # Fake machine version.
779 env="${env} UTS_MACHINE=${BUILD_ARCH}"
780
781 echo "${env}"
782}
783
784qemu_environ() {
785 local env
786
787 # Don't add anything if qemu is not used.
788 if ! qemu_is_required; then
789 return
790 fi
791
792 # Set default qemu options
793 case "${BUILD_ARCH}" in
794 arm*)
795 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
796
797 env="${env} QEMU_CPU=${QEMU_CPU}"
798 ;;
799 esac
800
801 # Enable QEMU strace
802 #env="${env} QEMU_STRACE=1"
803
804 echo "${env}"
805}
806
807qemu_is_required() {
808 local build_arch="${1}"
809
810 if [ -z "${build_arch}" ]; then
811 build_arch="${BUILD_ARCH}"
812 fi
813
814 case "${HOST_ARCH},${build_arch}" in
161eb15d 815 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
816 return 0
817 ;;
818 *)
819 return 1
820 ;;
821 esac
822}
823
824qemu_install_helper() {
825 # Do nothing, if qemu is not required
826 if ! qemu_is_required; then
827 return 0
828 fi
829
830 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
831 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
832 fi
833
834 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
835 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
836 fi
837
838
839 if [ -z "${QEMU_TARGET_HELPER}" ]; then
840 exiterror "QEMU_TARGET_HELPER not set"
841 fi
842
843 # Check if the helper is already installed.
844 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
845 return 0
846 fi
847
848 # Try to find a suitable binary that we can install
849 # to the build environment.
850 local file
851 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
852 # file must exist and be executable.
853 [ -x "${file}" ] || continue
854
855 # Must be static.
856 file_is_static "${file}" || continue
857
858 local dirname="${LFS}$(dirname "${file}")"
859 mkdir -p "${dirname}"
860
861 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
862 return 0
863 done
864
865 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
866}
867
868qemu_find_build_helper_name() {
869 local build_arch="${1}"
870
871 local magic
872 case "${build_arch}" in
0db0f7fa
AF
873 aarch64)
874 magic="7f454c460201010000000000000000000200b700"
875 ;;
4576ca4c
MT
876 arm*)
877 magic="7f454c4601010100000000000000000002002800"
878 ;;
161eb15d
MT
879 riscv64)
880 magic="7f454c460201010000000000000000000200f300"
881 ;;
69a6ec55
MT
882 x86_64)
883 magic="7f454c4602010100000000000000000002003e00"
884 ;;
885 esac
886
887 [ -z "${magic}" ] && return 1
888
889 local file
890 for file in /proc/sys/fs/binfmt_misc/*; do
891 # skip write only register entry
892 [ $(basename "${file}") = "register" ] && continue
893 # Search for the file with the correct magic value.
894 grep -qE "^magic ${magic}$" "${file}" || continue
895
896 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
897
898 [ -n "${interpreter}" ] || continue
899 [ "${interpreter:0:1}" = "/" ] || continue
900 [ -x "${interpreter}" ] || continue
901
902 echo "${interpreter}"
903 return 0
904 done
905
906 return 1
907}
908
909file_is_static() {
910 local file="${1}"
911
912 file ${file} 2>/dev/null | grep -q "statically linked"
913}
914
915update_language_list() {
916 local path="${1}"
917
918 local lang
919 for lang in ${path}/*.po; do
920 lang="$(basename "${lang}")"
921 echo "${lang%*.po}"
922 done | sort -u > "${path}/LINGUAS"
923}
924
1fb7f56e
MT
925contributors() {
926 local commits name
927
928 git shortlog --summary --numbered | while read -r commits name; do
929 echo "${name}"
930 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
931}
932
933update_contributors() {
934 echo -n "Updating list of contributors"
935
936 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
937
938 # Edit contributors into credits.cgi
e2338aa7
MT
939 local tmp="$(mktemp)"
940
941 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
942 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
943
944 # Copy back modified content
945 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
946 unlink "${tmp}"
1fb7f56e
MT
947
948 print_status DONE
949 return 0
950}
951
15b005d8 952# Default settings
99597de7 953CCACHE_CACHE_SIZE="4G"
15b005d8
MT
954ENABLE_RAMDISK="auto"
955
a98ab1d7
MT
956# Load configuration file
957if [ -f .config ]; then
958 . .config
959fi
960
813659f2
MT
961# TARGET_ARCH is BUILD_ARCH now
962if [ -n "${TARGET_ARCH}" ]; then
963 BUILD_ARCH="${TARGET_ARCH}"
964 unset TARGET_ARCH
965fi
966
85560933
MT
967# Get some information about the host system
968SYSTEM_PROCESSORS="$(system_processors)"
969SYSTEM_MEMORY="$(system_memory)"
970
dc7d6b20
MT
971if [ -n "${BUILD_ARCH}" ]; then
972 configure_build "${BUILD_ARCH}"
949544f5 973else
dc7d6b20 974 configure_build "default"
949544f5
MT
975fi
976
15b005d8
MT
977# Automatically enable/disable ramdisk usage
978if [ "${ENABLE_RAMDISK}" = "auto" ]; then
979 # Enable only when the host system has 4GB of RAM or more
980 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
981 ENABLE_RAMDISK="on"
982 fi
983fi
984
df5e82b3 985buildtoolchain() {
69a6ec55
MT
986 local error=false
987 case "${BUILD_ARCH}:${HOST_ARCH}" in
988 # x86_64
989 x86_64:x86_64)
990 # This is working.
991 ;;
992
993 # x86
994 i586:i586|i586:i686|i586:x86_64)
995 # These are working.
996 ;;
997 i586:*)
998 error=true
999 ;;
1000
1001 # ARM
1002 arvm7hl:armv7hl|armv7hl:armv7l)
1003 # These are working.
1004 ;;
1005
aafdd71b 1006 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
69a6ec55
MT
1007 # These are working.
1008 ;;
aafdd71b 1009 armv6l:*)
69a6ec55
MT
1010 error=true
1011 ;;
1012 esac
1013
1014 ${error} && \
1015 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1016
1017 local gcc=$(type -p gcc)
1018 if [ -z "${gcc}" ]; then
1019 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1020 fi
1021
6bd3a131
MT
1022 # Check ${TOOLS_DIR} symlink
1023 if [ -h "${TOOLS_DIR}" ]; then
1024 rm -f "${TOOLS_DIR}"
1025 fi
1026
1027 if [ ! -e "${TOOLS_DIR}" ]; then
1028 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1029 fi
1030
1031 if [ ! -h "${TOOLS_DIR}" ]; then
1032 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1033 fi
1034
ebaecf2c 1035 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1036 export LOGFILE
1037
1038 lfsmake1 stage1
69a6ec55
MT
1039 lfsmake1 binutils PASS=1
1040 lfsmake1 gcc PASS=1
1041 lfsmake1 linux KCFG="-headers"
1042 lfsmake1 glibc
178c7a6a 1043 lfsmake1 libxcrypt
69a6ec55 1044 lfsmake1 gcc PASS=L
54d54148 1045 lfsmake1 zlib
2d29899d 1046 lfsmake1 zstd
7d14c775
MT
1047 lfsmake1 binutils PASS=2
1048 lfsmake1 gcc PASS=2
74ee1c7a 1049 lfsmake1 ccache
69a6ec55
MT
1050 lfsmake1 tcl
1051 lfsmake1 expect
1052 lfsmake1 dejagnu
1053 lfsmake1 pkg-config
1054 lfsmake1 ncurses
1055 lfsmake1 bash
1056 lfsmake1 bzip2
1057 lfsmake1 automake
1058 lfsmake1 coreutils
1059 lfsmake1 diffutils
1060 lfsmake1 findutils
1061 lfsmake1 gawk
1062 lfsmake1 gettext
1063 lfsmake1 grep
1064 lfsmake1 gzip
1065 lfsmake1 m4
1066 lfsmake1 make
1067 lfsmake1 patch
1068 lfsmake1 perl
46bbc13b 1069 lfsmake1 python3
69a6ec55
MT
1070 lfsmake1 sed
1071 lfsmake1 tar
1072 lfsmake1 texinfo
1073 lfsmake1 xz
85439ac7 1074 lfsmake1 bison
11b5e5cb 1075 lfsmake1 flex
69a6ec55 1076 lfsmake1 fake-environ
7b93b62b 1077 lfsmake1 strip
69a6ec55 1078 lfsmake1 cleanup-toolchain
df5e82b3
MT
1079}
1080
1081buildbase() {
ebaecf2c 1082 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1083 export LOGFILE
1084 lfsmake2 stage2
1085 lfsmake2 linux KCFG="-headers"
1086 lfsmake2 man-pages
1087 lfsmake2 glibc
1088 lfsmake2 tzdata
1089 lfsmake2 cleanup-toolchain
1090 lfsmake2 zlib
b14c24ca 1091 lfsmake2 zstd
cf6c8e67
MT
1092 lfsmake2 autoconf
1093 lfsmake2 automake
1094 lfsmake2 libtool
69a6ec55
MT
1095 lfsmake2 binutils
1096 lfsmake2 gmp
69a6ec55
MT
1097 lfsmake2 mpfr
1098 lfsmake2 libmpc
cf6c8e67 1099 lfsmake2 libxcrypt
69a6ec55
MT
1100 lfsmake2 file
1101 lfsmake2 gcc
1102 lfsmake2 sed
69a6ec55
MT
1103 lfsmake2 berkeley
1104 lfsmake2 coreutils
1105 lfsmake2 iana-etc
1106 lfsmake2 m4
1107 lfsmake2 bison
69a6ec55 1108 lfsmake2 ncurses
69a6ec55
MT
1109 lfsmake2 perl
1110 lfsmake2 readline
69a6ec55 1111 lfsmake2 bzip2
3ece7859 1112 lfsmake2 xz
f407f05a 1113 lfsmake2 lzip
69a6ec55 1114 lfsmake2 pcre
b0c37190 1115 lfsmake2 pcre2
d701756a 1116 lfsmake2 gettext
241bf919
MT
1117 lfsmake2 attr
1118 lfsmake2 acl
69a6ec55
MT
1119 lfsmake2 bash
1120 lfsmake2 diffutils
69a6ec55
MT
1121 lfsmake2 ed
1122 lfsmake2 findutils
1123 lfsmake2 flex
1124 lfsmake2 gawk
d2315d00 1125 lfsmake2 go
69a6ec55
MT
1126 lfsmake2 grep
1127 lfsmake2 groff
1128 lfsmake2 gperf
1129 lfsmake2 gzip
1130 lfsmake2 hostname
1131 lfsmake2 iproute2
1132 lfsmake2 jwhois
1133 lfsmake2 kbd
1134 lfsmake2 less
4720fa0d 1135 lfsmake2 pkg-config
50992c73 1136 lfsmake2 procps
69a6ec55
MT
1137 lfsmake2 make
1138 lfsmake2 man
69a6ec55
MT
1139 lfsmake2 net-tools
1140 lfsmake2 patch
1141 lfsmake2 psmisc
1142 lfsmake2 shadow
1143 lfsmake2 sysklogd
1144 lfsmake2 sysvinit
1145 lfsmake2 tar
1146 lfsmake2 texinfo
1147 lfsmake2 util-linux
69a6ec55 1148 lfsmake2 vim
69b3d63b 1149 lfsmake2 e2fsprogs
df5e82b3
MT
1150}
1151
15679d9f 1152buildipfire() {
ebaecf2c 1153 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1154 export LOGFILE
489145db
MT
1155 lfsmake2 configroot
1156 lfsmake2 initscripts
1157 lfsmake2 backup
c38f55fe 1158 lfsmake2 openssl
1ece41ec 1159 lfsmake2 kmod
e1c6cd05 1160 lfsmake2 udev
3755e358 1161 lfsmake2 popt
d4767896 1162 lfsmake2 libedit
489145db
MT
1163 lfsmake2 libusb
1164 lfsmake2 libusb-compat
1165 lfsmake2 libpcap
1166 lfsmake2 ppp
1167 lfsmake2 pptp
1168 lfsmake2 unzip
1169 lfsmake2 which
1170 lfsmake2 linux-firmware
489145db 1171 lfsmake2 dvb-firmwares
37b86fa9 1172 lfsmake2 xr819-firmware
489145db
MT
1173 lfsmake2 zd1211-firmware
1174 lfsmake2 rpi-firmware
26796f3a 1175 lfsmake2 intel-microcode
0e54ca26 1176 lfsmake2 pcengines-apu-firmware
489145db 1177 lfsmake2 bc
2a0947f2 1178 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1179 lfsmake2 cpio
1180 lfsmake2 mdadm
1181 lfsmake2 dracut
de18b4de 1182 lfsmake2 libaio
489145db
MT
1183 lfsmake2 lvm2
1184 lfsmake2 multipath-tools
1185 lfsmake2 freetype
489145db
MT
1186 lfsmake2 libmnl
1187 lfsmake2 libnfnetlink
1188 lfsmake2 libnetfilter_queue
1189 lfsmake2 libnetfilter_conntrack
1190 lfsmake2 libnetfilter_cthelper
1191 lfsmake2 libnetfilter_cttimeout
1192 lfsmake2 iptables
0245f3b6 1193 lfsmake2 screen
54ead8ef 1194 lfsmake2 elfutils
8e6fb99d 1195
efafef16
AF
1196 # Kernelbuild ... current we have no platform that need
1197 # multi kernel builds so KCFG is empty
1198 lfsmake2 linux KCFG=""
1199 lfsmake2 rtl8189es KCFG=""
1200 lfsmake2 rtl8812au KCFG=""
1201 lfsmake2 xradio KCFG=""
1202 lfsmake2 xtables-addons KCFG=""
1203 lfsmake2 linux-initrd KCFG=""
1204
1205 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1206 lfsmake2 libgpg-error
1207 lfsmake2 libgcrypt
1208 lfsmake2 libassuan
1209 lfsmake2 nettle
1a7db134 1210 lfsmake2 json-c
f3e62301 1211 lfsmake2 libconfig
489145db
MT
1212 lfsmake2 libevent
1213 lfsmake2 libevent2
1214 lfsmake2 expat
c8e9a7a8
WA
1215 lfsmake2 apr
1216 lfsmake2 aprutil
489145db
MT
1217 lfsmake2 unbound
1218 lfsmake2 gnutls
1219 lfsmake2 bind
1220 lfsmake2 dhcp
1221 lfsmake2 dhcpcd
1222 lfsmake2 boost
1223 lfsmake2 linux-atm
1224 lfsmake2 gdbm
1225 lfsmake2 pam
d44ce7d4 1226 lfsmake2 c-ares
489145db
MT
1227 lfsmake2 curl
1228 lfsmake2 tcl
1229 lfsmake2 sqlite
1230 lfsmake2 libffi
1231 lfsmake2 python
1232 lfsmake2 python3
8a4495a4 1233 lfsmake2 gdb
b3ce3510
MT
1234 lfsmake2 grub
1235 lfsmake2 efivar
1236 lfsmake2 efibootmgr
489145db
MT
1237 lfsmake2 ca-certificates
1238 lfsmake2 fireinfo
1239 lfsmake2 libnet
1240 lfsmake2 libnl
1241 lfsmake2 libnl-3
1242 lfsmake2 libidn
1243 lfsmake2 nasm
4f516b87
MF
1244 lfsmake2 libarchive
1245 lfsmake2 cmake
814a33ff
SS
1246 lfsmake2 ninja
1247 lfsmake2 meson
489145db 1248 lfsmake2 libjpeg
58d965fe 1249 lfsmake2 openjpeg
489145db
MT
1250 lfsmake2 libexif
1251 lfsmake2 libpng
1252 lfsmake2 libtiff
1253 lfsmake2 libart
1254 lfsmake2 gd
489145db
MT
1255 lfsmake2 slang
1256 lfsmake2 newt
1257 lfsmake2 libsmooth
489145db 1258 lfsmake2 libcap
b051eb68 1259 lfsmake2 libcap-ng
489145db
MT
1260 lfsmake2 pciutils
1261 lfsmake2 usbutils
1262 lfsmake2 libxml2
1263 lfsmake2 libxslt
1264 lfsmake2 BerkeleyDB
489145db
MT
1265 lfsmake2 cyrus-sasl
1266 lfsmake2 openldap
1267 lfsmake2 apache2
489145db
MT
1268 lfsmake2 web-user-interface
1269 lfsmake2 flag-icons
1270 lfsmake2 jquery
6033b271 1271 lfsmake2 bootstrap
489145db
MT
1272 lfsmake2 arping
1273 lfsmake2 beep
1df47cc9 1274 lfsmake2 libssh
ff075def 1275 lfsmake2 libinih
8a960584 1276 lfsmake2 cdrkit
489145db
MT
1277 lfsmake2 dosfstools
1278 lfsmake2 reiserfsprogs
1279 lfsmake2 xfsprogs
1280 lfsmake2 sysfsutils
1281 lfsmake2 fuse
1282 lfsmake2 ntfs-3g
1283 lfsmake2 ethtool
489145db
MT
1284 lfsmake2 fcron
1285 lfsmake2 perl-GD
1286 lfsmake2 GD-Graph
1287 lfsmake2 GD-TextUtil
1288 lfsmake2 perl-Device-SerialPort
1289 lfsmake2 perl-Device-Modem
1290 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1291 lfsmake2 perl-Parse-Yapp
46426b69 1292 lfsmake2 perl-Data-UUID
489145db
MT
1293 lfsmake2 gnupg
1294 lfsmake2 hdparm
1295 lfsmake2 sdparm
489145db 1296 lfsmake2 whatmask
29370584 1297 lfsmake2 libtirpc
489145db 1298 lfsmake2 conntrack-tools
489145db
MT
1299 lfsmake2 iputils
1300 lfsmake2 l7-protocols
489145db
MT
1301 lfsmake2 hwdata
1302 lfsmake2 logrotate
1303 lfsmake2 logwatch
1304 lfsmake2 misc-progs
1305 lfsmake2 nano
1306 lfsmake2 URI
294aa009
AF
1307 lfsmake2 perl-CGI
1308 lfsmake2 perl-Switch
489145db
MT
1309 lfsmake2 HTML-Tagset
1310 lfsmake2 HTML-Parser
1311 lfsmake2 HTML-Template
1312 lfsmake2 Compress-Zlib
1313 lfsmake2 Digest
1314 lfsmake2 Digest-SHA1
1315 lfsmake2 Digest-HMAC
1316 lfsmake2 libwww-perl
1317 lfsmake2 Net-DNS
1318 lfsmake2 Net-IPv4Addr
1319 lfsmake2 Net_SSLeay
1320 lfsmake2 IO-Stringy
1321 lfsmake2 IO-Socket-SSL
1322 lfsmake2 Unix-Syslog
1323 lfsmake2 Mail-Tools
1324 lfsmake2 MIME-Tools
1325 lfsmake2 Net-Server
a7492c0f 1326 lfsmake2 Canary-Stability
489145db
MT
1327 lfsmake2 Convert-TNEF
1328 lfsmake2 Convert-UUlib
1329 lfsmake2 Archive-Tar
1330 lfsmake2 Archive-Zip
1331 lfsmake2 Text-Tabs+Wrap
489145db
MT
1332 lfsmake2 XML-Parser
1333 lfsmake2 Crypt-PasswdMD5
1334 lfsmake2 Net-Telnet
398669f7 1335 lfsmake2 python3-setuptools
d55a968a 1336 lfsmake2 python3-inotify
05fed717 1337 lfsmake2 python3-docutils
0882b3e4 1338 lfsmake2 python3-daemon
489145db 1339 lfsmake2 glib
489145db
MT
1340 lfsmake2 ntp
1341 lfsmake2 openssh
1342 lfsmake2 fontconfig
1343 lfsmake2 dejavu-fonts-ttf
70f6cba4 1344 lfsmake2 ubuntu-font-family
489145db
MT
1345 lfsmake2 freefont
1346 lfsmake2 pixman
1347 lfsmake2 cairo
1348 lfsmake2 pango
1349 lfsmake2 rrdtool
489145db
MT
1350 lfsmake2 setup
1351 lfsmake2 libdnet
59fe9735 1352 lfsmake2 rust
616395f3 1353 lfsmake2 jansson
91cc908f 1354 lfsmake2 yaml
3498300d 1355 lfsmake2 libhtp
1a5f0649 1356 lfsmake2 colm
2348cfff 1357 lfsmake2 ragel
52ebc66b 1358 lfsmake2 hyperscan
67752a95 1359 lfsmake2 suricata
489145db 1360 lfsmake2 oinkmaster
ef640882 1361 lfsmake2 ids-ruleset-sources
489145db
MT
1362 lfsmake2 squid
1363 lfsmake2 squidguard
1364 lfsmake2 calamaris
1365 lfsmake2 tcpdump
1366 lfsmake2 traceroute
1367 lfsmake2 vlan
1368 lfsmake2 wireless
1369 lfsmake2 pakfire
1370 lfsmake2 spandsp
adf3f4f4 1371 lfsmake2 lz4
489145db
MT
1372 lfsmake2 lzo
1373 lfsmake2 openvpn
489145db
MT
1374 lfsmake2 mpage
1375 lfsmake2 dbus
1376 lfsmake2 intltool
1377 lfsmake2 libdaemon
6064cd87 1378 lfsmake2 avahi
489145db 1379 lfsmake2 cups
489145db 1380 lfsmake2 lcms2
56170c2a 1381 lfsmake2 ghostscript
489145db
MT
1382 lfsmake2 qpdf
1383 lfsmake2 poppler
d3dabd4b 1384 lfsmake2 poppler-data
489145db
MT
1385 lfsmake2 cups-filters
1386 lfsmake2 epson-inkjet-printer-escpr
1387 lfsmake2 foomatic
1388 lfsmake2 hplip
1389 lfsmake2 cifs-utils
1390 lfsmake2 krb5
95849177 1391 lfsmake2 rpcsvc-proto
489145db 1392 lfsmake2 samba
18d000c4 1393 lfsmake2 netatalk
489145db
MT
1394 lfsmake2 sudo
1395 lfsmake2 mc
1396 lfsmake2 wget
1397 lfsmake2 bridge-utils
489145db
MT
1398 lfsmake2 smartmontools
1399 lfsmake2 htop
1400 lfsmake2 chkconfig
1401 lfsmake2 postfix
1402 lfsmake2 fetchmail
489145db 1403 lfsmake2 clamav
294aa009 1404 lfsmake2 perl-NetAddr-IP
489145db
MT
1405 lfsmake2 dma
1406 lfsmake2 alsa
1407 lfsmake2 mpfire
1408 lfsmake2 guardian
1409 lfsmake2 libid3tag
1410 lfsmake2 libmad
1411 lfsmake2 libogg
1412 lfsmake2 libvorbis
489145db
MT
1413 lfsmake2 flac
1414 lfsmake2 lame
1415 lfsmake2 sox
41f8d642 1416 lfsmake2 soxr
489145db
MT
1417 lfsmake2 libshout
1418 lfsmake2 xvid
1419 lfsmake2 libmpeg2
489145db
MT
1420 lfsmake2 gnump3d
1421 lfsmake2 rsync
489145db 1422 lfsmake2 rpcbind
14fb55a5 1423 lfsmake2 keyutils
8af744bc 1424 lfsmake2 libnfsidmap
489145db
MT
1425 lfsmake2 nfs
1426 lfsmake2 gnu-netcat
1427 lfsmake2 ncat
1428 lfsmake2 nmap
489145db
MT
1429 lfsmake2 etherwake
1430 lfsmake2 bwm-ng
1431 lfsmake2 sysstat
489145db
MT
1432 lfsmake2 strongswan
1433 lfsmake2 rng-tools
1434 lfsmake2 lsof
1435 lfsmake2 br2684ctl
1436 lfsmake2 pcmciautils
1437 lfsmake2 lm_sensors
25f26fb6 1438 lfsmake2 libstatgrab
489145db
MT
1439 lfsmake2 liboping
1440 lfsmake2 collectd
1441 lfsmake2 elinks
1442 lfsmake2 igmpproxy
489145db 1443 lfsmake2 opus
495cf3e0 1444 lfsmake2 python3-pyparsing
489145db
MT
1445 lfsmake2 spice-protocol
1446 lfsmake2 spice
1447 lfsmake2 sdl
1448 lfsmake2 libusbredir
43c3a386 1449 lfsmake2 libseccomp
489145db 1450 lfsmake2 qemu
489145db 1451 lfsmake2 netpbm
489145db 1452 lfsmake2 netsnmpd
489145db 1453 lfsmake2 nagios_nrpe
2af354c2 1454 lfsmake2 nagios-plugins
489145db 1455 lfsmake2 icinga
01c2ea6b 1456 lfsmake2 observium-agent
489145db 1457 lfsmake2 ebtables
489145db 1458 lfsmake2 faad2
e91ceed6 1459 lfsmake2 alac
489145db
MT
1460 lfsmake2 ffmpeg
1461 lfsmake2 vdr
1462 lfsmake2 vdr_streamdev
489145db
MT
1463 lfsmake2 vdr_epgsearch
1464 lfsmake2 vdr_dvbapi
1465 lfsmake2 vdr_eepg
1466 lfsmake2 w_scan
489145db
MT
1467 lfsmake2 mpd
1468 lfsmake2 libmpdclient
1469 lfsmake2 mpc
985741db 1470 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1471 lfsmake2 perl-Net-SMTP-SSL
1472 lfsmake2 perl-MIME-Base64
1473 lfsmake2 perl-Authen-SASL
1474 lfsmake2 perl-MIME-Lite
1475 lfsmake2 perl-Email-Date-Format
1476 lfsmake2 git
1477 lfsmake2 squidclamav
1478 lfsmake2 vnstat
1479 lfsmake2 iw
1480 lfsmake2 wpa_supplicant
1481 lfsmake2 hostapd
489145db
MT
1482 lfsmake2 syslinux
1483 lfsmake2 tftpd
1484 lfsmake2 cpufrequtils
489145db
MT
1485 lfsmake2 gutenprint
1486 lfsmake2 apcupsd
67fbd255 1487 lfsmake2 fireperf
489145db
MT
1488 lfsmake2 iperf
1489 lfsmake2 iperf3
1490 lfsmake2 7zip
1491 lfsmake2 lynis
489145db
MT
1492 lfsmake2 sshfs
1493 lfsmake2 taglib
489145db
MT
1494 lfsmake2 sslh
1495 lfsmake2 perl-gettext
1496 lfsmake2 perl-Sort-Naturally
1497 lfsmake2 vdradmin
489145db 1498 lfsmake2 perl-DBI
489145db
MT
1499 lfsmake2 perl-DBD-SQLite
1500 lfsmake2 perl-File-ReadBackwards
489145db 1501 lfsmake2 openvmtools
489145db
MT
1502 lfsmake2 joe
1503 lfsmake2 monit
1504 lfsmake2 nut
1505 lfsmake2 watchdog
1506 lfsmake2 libpri
489145db
MT
1507 lfsmake2 usb_modeswitch
1508 lfsmake2 usb_modeswitch_data
1509 lfsmake2 zerofree
489145db
MT
1510 lfsmake2 minicom
1511 lfsmake2 ddrescue
489145db
MT
1512 lfsmake2 client175
1513 lfsmake2 powertop
1514 lfsmake2 parted
1515 lfsmake2 swig
2a0947f2 1516 lfsmake2 u-boot
6836e528 1517 lfsmake2 u-boot-friendlyarm
489145db 1518 lfsmake2 wireless-regdb
489145db 1519 lfsmake2 libsolv
489145db 1520 lfsmake2 ddns
662b2a81 1521 lfsmake2 python3-setuptools-scm
5996c281 1522 lfsmake2 python3-six
e0a05a80 1523 lfsmake2 python3-dateutil
d48ea6b5 1524 lfsmake2 python3-jmespath
a33ca4cc 1525 lfsmake2 python3-colorama
d2da17a1 1526 lfsmake2 python3-yaml
953f6f73 1527 lfsmake2 python3-s3transfer
d45d5247 1528 lfsmake2 python3-rsa
faa5472a 1529 lfsmake2 python3-pyasn1
05be1c64 1530 lfsmake2 python3-urllib3
4ab80c5d 1531 lfsmake2 python3-botocore
def9f4a3 1532 lfsmake2 python3-msgpack
280ee7e7 1533 lfsmake2 aws-cli
489145db 1534 lfsmake2 transmission
489145db 1535 lfsmake2 mtr
489145db
MT
1536 lfsmake2 minidlna
1537 lfsmake2 acpid
1538 lfsmake2 fping
1539 lfsmake2 telnet
1540 lfsmake2 xinetd
489145db 1541 lfsmake2 stress
489145db 1542 lfsmake2 sarg
489145db 1543 lfsmake2 nginx
489145db
MT
1544 lfsmake2 sysbench
1545 lfsmake2 strace
489145db
MT
1546 lfsmake2 ltrace
1547 lfsmake2 ipfire-netboot
1548 lfsmake2 lcdproc
489145db
MT
1549 lfsmake2 keepalived
1550 lfsmake2 ipvsadm
1551 lfsmake2 perl-Carp-Clan
1552 lfsmake2 perl-Date-Calc
1553 lfsmake2 perl-Date-Manip
1554 lfsmake2 perl-File-Tail
1555 lfsmake2 perl-TimeDate
1556 lfsmake2 swatch
1557 lfsmake2 tor
489145db
MT
1558 lfsmake2 wavemon
1559 lfsmake2 iptraf-ng
1560 lfsmake2 iotop
1561 lfsmake2 stunnel
489145db 1562 lfsmake2 bacula
b62c826f
MT
1563 lfsmake2 perl-Font-TTF
1564 lfsmake2 perl-IO-String
489145db
MT
1565 lfsmake2 perl-PDF-API2
1566 lfsmake2 squid-accounting
1567 lfsmake2 pigz
1568 lfsmake2 tmux
1569 lfsmake2 perl-Text-CSV_XS
09b09b85 1570 lfsmake2 lua
489145db
MT
1571 lfsmake2 haproxy
1572 lfsmake2 ipset
489145db
MT
1573 lfsmake2 dnsdist
1574 lfsmake2 bird
1a7db134 1575 lfsmake2 frr
489145db
MT
1576 lfsmake2 dmidecode
1577 lfsmake2 mcelog
489145db
MT
1578 lfsmake2 util-macros
1579 lfsmake2 libpciaccess
1580 lfsmake2 libyajl
1581 lfsmake2 libvirt
42fca290 1582 lfsmake2 libtalloc
489145db
MT
1583 lfsmake2 freeradius
1584 lfsmake2 perl-common-sense
1585 lfsmake2 perl-inotify2
1586 lfsmake2 perl-Net-IP
0d6cc79d 1587 lfsmake2 wio
773caa66 1588 lfsmake2 iftop
ddcd60f7 1589 lfsmake2 mdns-repeater
429af178 1590 lfsmake2 i2c-tools
4e9000b4 1591 lfsmake2 nss-myhostname
014b235a 1592 lfsmake2 dehydrated
c708fa15 1593 lfsmake2 shairport-sync
46114d79 1594 lfsmake2 borgbackup
50483167 1595 lfsmake2 lmdb
2397e513 1596 lfsmake2 knot
e1982c69 1597 lfsmake2 spectre-meltdown-checker
06fc6170 1598 lfsmake2 zabbix_agentd
82d176d3 1599 lfsmake2 flashrom
2aca6aa0 1600 lfsmake2 firmware-update
ffcef39d 1601 lfsmake2 tshark
9875e9f2 1602 lfsmake2 speedtest-cli
0db643ce 1603 lfsmake2 rfkill
44cc9a3d 1604 lfsmake2 amazon-ssm-agent
d938509e 1605 lfsmake2 libloc
4d275bcd 1606 lfsmake2 ncdu
76c5f3e0 1607 lfsmake2 lshw
68fbcc0e 1608 lfsmake2 socat
7300386b
AB
1609 lfsmake2 libcdada
1610 lfsmake2 pmacct
d0817963 1611}
df5e82b3
MT
1612
1613buildinstaller() {
1614 # Run installer scripts one by one
ebaecf2c 1615 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1616 export LOGFILE
489145db
MT
1617 lfsmake2 memtest
1618 lfsmake2 installer
ce9264a1
AF
1619 # use toolchain bash for chroot to strip
1620 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1621}
1622
1623buildpackages() {
ebaecf2c 1624 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1625 export LOGFILE
1626 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1627
df5e82b3
MT
1628
1629 # Generating list of packages used
dc4ae0b7 1630 print_line "Generating packages list from logs"
df5e82b3 1631 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1632 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1633 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1634 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1635 fi
1636 done
7471f6ab 1637 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1638 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1639 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1640 rm -f $BASEDIR/doc/packages-list
c9673262 1641 # packages-list.txt is ready to be displayed for wiki page
f9783277 1642 print_status DONE
4b06f504
MT
1643
1644 # Update changelog
e49f7f0d 1645 cd $BASEDIR
c43b07fd
AF
1646 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1647 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1648 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1649
9607771a 1650 # Create images for install
489145db 1651 lfsmake2 cdrom
bada0832 1652
4dc82852 1653 # Check if there is a loop device for building in virtual environments
841663e7
MT
1654 modprobe loop 2>/dev/null
1655 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1656 lfsmake2 flash-images
4dc82852 1657 fi
c9673262 1658
c4dd9dfc 1659 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1660
0d909a4a 1661 ipfirepackages
e67a57fe 1662
b307417f 1663 cd $BASEDIR
744a04ea 1664
aafdd71b
AF
1665 # remove not useable iso on armv6l (needed to build flash images)
1666 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
744a04ea 1667
5336aaa6 1668 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
b307417f
AF
1669 md5sum $i > $i.md5
1670 done
1671 cd $PWD
1672
e67a57fe
MT
1673 # Cleanup
1674 stdumount
1675 rm -rf $BASEDIR/build/tmp/*
1676
e67a57fe 1677 cd $PWD
e67a57fe
MT
1678}
1679
1680ipfirepackages() {
489145db 1681 lfsmake2 core-updates
5596077b
MT
1682
1683 local i
dc7d6b20 1684 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1685 i=$(basename ${i})
453b418b
MT
1686 if [ -e $BASEDIR/lfs/$i ]; then
1687 ipfiredist $i
1688 else
1689 echo -n $i
f9783277 1690 print_status SKIP
453b418b 1691 fi
fe7fe395 1692 done
78331e30 1693 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1694 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1695 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1696}
1697
bcb9dc13
MT
1698while [ $# -gt 0 ]; do
1699 case "${1}" in
1700 --target=*)
c2e810de 1701 configure_build "${1#--target=}"
bcb9dc13
MT
1702 ;;
1703 -*)
1704 exiterror "Unknown configuration option: ${1}"
1705 ;;
1706 *)
1707 # Found a command, so exit options parsing.
1708 break
1709 ;;
1710 esac
1711 shift
1712done
1713
df5e82b3
MT
1714# See what we're supposed to do
1715case "$1" in
1716build)
f9783277
MT
1717 START_TIME=$(now)
1718
1719 # Clear screen
1720 ${INTERACTIVE} && clear
1721
d66e6fa8 1722 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
df5e82b3 1723 #only restore on a clean disk
6c4cc7ea 1724 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1725 if [ ! -n "$PACKAGE" ]; then
f9783277 1726 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1727 prepareenv
1728 buildtoolchain
1729 else
d66e6fa8 1730 PACKAGENAME=${PACKAGE%.tar.zst}
f9783277 1731 print_build_stage "Packaged toolchain compilation"
df5e82b3 1732 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
cec532b4 1733 zstd -d < "${PACKAGE}" | tar x
df5e82b3
MT
1734 prepareenv
1735 else
1736 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1737 fi
1738 fi
1739 else
df5e82b3
MT
1740 prepareenv
1741 fi
5cfe86e6 1742
f9783277 1743 print_build_stage "Building LFS"
df5e82b3 1744 buildbase
15679d9f 1745
f9783277 1746 print_build_stage "Building IPFire"
15679d9f 1747 buildipfire
5cfe86e6 1748
f9783277 1749 print_build_stage "Building installer"
df5e82b3 1750 buildinstaller
15679d9f 1751
f9783277 1752 print_build_stage "Building packages"
df5e82b3 1753 buildpackages
7a5ed24e 1754
f9783277 1755 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1756
1757 cd $BASEDIR
7a5ed24e 1758 tools/checknewlog.pl
e0c923f4 1759 tools/checkrootfiles
b307417f 1760 cd $PWD
a23731d1 1761
f9783277 1762 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1763 ;;
1764shell)
1765 # enter a shell inside LFS chroot
1766 # may be used to changed kernel settings
1767 prepareenv
1768 entershell
1769 ;;
df5e82b3 1770clean)
f9783277
MT
1771 print_line "Cleaning build directory..."
1772
df5e82b3
MT
1773 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1774 $LOSETUP -d $i 2>/dev/null
1775 done
b0c37190
MT
1776 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1777 # umount $i
1778 #done
df5e82b3
MT
1779 stdumount
1780 for i in `seq 0 7`; do
69a6ec55 1781 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1782 umount /dev/loop${i} 2>/dev/null;
1783 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1784 fi;
df5e82b3
MT
1785 done
1786 rm -rf $BASEDIR/build
1787 rm -rf $BASEDIR/cdrom
f9315063 1788 rm -rf $BASEDIR/packages
ebaecf2c 1789 rm -rf $BASEDIR/log
6c4cc7ea
MT
1790 if [ -h "${TOOLS_DIR}" ]; then
1791 rm -f "${TOOLS_DIR}"
df5e82b3 1792 fi
b307417f 1793 rm -f $BASEDIR/ipfire-*
f9783277 1794 print_status DONE
df5e82b3 1795 ;;
4e432799
MT
1796docker)
1797 # Build the docker image if it does not exist, yet
1798 if ! docker images -a | grep -q ^ipfire-builder; then
1799 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1800 print_status DONE
1801 else
1802 print_status FAIL
1803 exit 1
1804 fi
1805 fi
1806
1807 # Run the container and enter a shell
1808 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1809 ;;
c3db995c 1810downloadsrc)
df5e82b3
MT
1811 if [ ! -d $BASEDIR/cache ]; then
1812 mkdir $BASEDIR/cache
1813 fi
ebaecf2c 1814 mkdir -p $BASEDIR/log
857d9bf2 1815 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1816 FINISHED=0
1817 cd $BASEDIR/lfs
1818 for c in `seq $MAX_RETRIES`; do
1819 if (( FINISHED==1 )); then
1820 break
1821 fi
1822 FINISHED=1
1823 cd $BASEDIR/lfs
1824 for i in *; do
1825 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1826 lfsmakecommoncheck ${i} || continue
1827
dc7d6b20 1828 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1829 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1830 if [ $? -ne 0 ]; then
f9783277 1831 print_status FAIL
df5e82b3
MT
1832 FINISHED=0
1833 else
1834 if [ $c -eq 1 ]; then
f9783277 1835 print_status DONE
df5e82b3
MT
1836 fi
1837 fi
1838 fi
1839 done
1840 done
e22c7973 1841 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1842 ERROR=0
1843 for i in *; do
1844 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1845 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1846 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1847 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1848 if [ $? -ne 0 ]; then
e22c7973 1849 echo -ne "MD5 difference in lfs/$i"
f9783277 1850 print_status FAIL
df5e82b3
MT
1851 ERROR=1
1852 fi
1853 fi
1854 done
1855 if [ $ERROR -eq 0 ]; then
e22c7973 1856 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1857 print_status DONE
e22c7973
MT
1858 else
1859 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1860 print_status FAIL
df5e82b3 1861 fi
e22c7973 1862 cd - >/dev/null 2>&1
df5e82b3 1863 ;;
df5e82b3 1864toolchain)
f9783277
MT
1865 # Clear screen
1866 ${INTERACTIVE} && clear
1867
df5e82b3 1868 prepareenv
f3b7cf47 1869 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1870 buildtoolchain
f74072a2 1871 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1872 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
d66e6fa8
MT
1873 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1874 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1875 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
dc7d6b20 1876 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1877 stdumount
1878 ;;
1879gettoolchain)
df5e82b3 1880 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1881 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
d66e6fa8 1882 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
5bd13f01 1883 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1884 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1885 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1886 cd $BASEDIR/cache/toolchains
d66e6fa8 1887 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1888 if [ $? -ne 0 ]; then
dc7d6b20 1889 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1890 else
5d099c0e 1891 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1892 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1893 else
1894 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1895 fi
40a4ea4c 1896 fi
712d859c
MT
1897 else
1898 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1899 fi
1900 ;;
15679d9f
MT
1901uploadsrc)
1902 PWD=`pwd`
661d9388
CS
1903 if [ -z $IPFIRE_USER ]; then
1904 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1905 print_status FAIL
661d9388
CS
1906 exit 1
1907 fi
ae23a606 1908
661d9388 1909 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1910 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1911
15e38431
MT
1912 for file in ${BASEDIR}/cache/*; do
1913 [ -d "${file}" ] && continue
1914 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1915 NEW_FILES="$NEW_FILES $file"
0eab8e84 1916 done
661d9388
CS
1917 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1918 cd $BASEDIR
15679d9f
MT
1919 cd $PWD
1920 exit 0
0eab8e84 1921 ;;
bf7c473f 1922lang)
69a6ec55
MT
1923 echo -ne "Checking the translations for missing or obsolete strings..."
1924 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1925 $BASEDIR/tools/sort_strings.pl en
1926 $BASEDIR/tools/sort_strings.pl de
1927 $BASEDIR/tools/sort_strings.pl fr
1928 $BASEDIR/tools/sort_strings.pl es
1929 $BASEDIR/tools/sort_strings.pl pl
1930 $BASEDIR/tools/sort_strings.pl ru
1931 $BASEDIR/tools/sort_strings.pl nl
1932 $BASEDIR/tools/sort_strings.pl tr
1933 $BASEDIR/tools/sort_strings.pl it
1934 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1935 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1936 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1937 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 1938 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
1939 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1940 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1941 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1942 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1943 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1944 print_status DONE
69a6ec55
MT
1945
1946 echo -ne "Updating language lists..."
1947 update_language_list ${BASEDIR}/src/installer/po
1948 update_language_list ${BASEDIR}/src/setup/po
f9783277 1949 print_status DONE
bf7c473f 1950 ;;
1fb7f56e
MT
1951update-contributors)
1952 update_contributors
1953 ;;
ba137dd8
MT
1954find-dependencies)
1955 shift
1956 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1957 ;;
6b8cff41 1958*)
ba137dd8 1959 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies}"
6b8cff41
MT
1960 cat doc/make.sh-usage
1961 ;;
3ea75603 1962esac
98329972 1963